; Puzzlin' version 1 (SNG 0.71)
; ------------------
; Created by Deus Makina
; NanoSoft
;
; June 2003
;
; Contact:
; www.tidev.fr.st
; tidev@fr.st  /  deus.makina@wanadoo.fr
; AIM: Deus Makina 2010
; MSN Messenger: deus_makina@hotmail.com
; ICQ: 176469620

; Thanks to developpers and their nice programs that make us dream.

; If you don't speak french, I'm sorry but comments are in french, but if somebody
; wants to translate them or to improve Puzzlin', please send me an e-mail ...

; PS : I've used 2 kinds of calls : - "call" in lowercase for my own routines
;                                   - "CALL" in caps for calls to rom or to shell

; ******************************************************************************
; ******************************************************************************
; ******************************************************************************
.include "sngbeta.inc"
         .db "Puzzlin  by Deus Makina",0
         jr demarrage

#define CLEAR_LCD    CLEARLCD
#define SH_BUF       TEXT_MEM2

rand_table    = SH_BUF          ; 16 bytes (cette contiendra les numeros aleatoires des blocs)
table_test    = SH_BUF + 16     ; 16 bytes (permet de determiner si des blocs ont deja t geners)

temp1_tile_m  = SH_BUF + 32     ; 1 byte
temp2_tile_m  = SH_BUF + 33     ; 1 byte

table_pad_coo = SH_BUF + 34     ; 2 bytes : le 1er = x, 2e = y  (pour le selecteur de la grille)

mode         = SH_BUF + 36      ; 1 byte  : mode de la fleche des etapes de selection

time_min     = SH_BUF + 37      ; 1 byte
time_sec     = SH_BUF + 38      ; 1 byte
time_counter = SH_BUF + 39      ; 1 byte

pos_menu     = SH_BUF + 40      ; 1 byte  : position du menu du demarrage

img_addr     = SH_BUF + 41      ; 2 bytes : contient l'adresse de l'image du puzzle selectionnee

level:                          ; 1 byte  : niveau de difficult
         .db 0
img_select:                     ; numero de l'image selectionnee
         .db 0
         
; ******************************************************************************
; ***************************  Menu des options  *******************************
; ******************************************************************************
demarrage:
; ***************  Effacement des donnees et des tables  ***********************
init_tables:
         ld hl,rand_table
         ld de,rand_table + 1
         ld (hl),0
         ld bc,31
         ldir                  ; on efface les 2 tables : 16 bytes + 16 bytes - 1 = 31


         xor a
         ld (table_pad_coo),a  ; initialisation du selecteur de la grille
         ld (table_pad_coo + 1),a
         ld (time_sec),a       ; initialisation du temps
         ld (time_min),a

         ld hl,GRAPH_MEM
         ld de,GRAPH_MEM + 1
         ld (hl),0
         ld bc,767
         ldir
         
         ld hl,banniere
         ld de,GRAPH_MEM
         ld bc,192
         ldir
         CALL CR_GRBCopy
         
; *********************************  Menu  *************************************
         xor a
         ld (pos_menu),a
         
scroll_menu:
         ld b,0                     ; numero de l'option actuelle du menu
         ld a,13                    ; = 23[position normale] - 10
         ld (CURSOR_Y),a
         
         ld hl,menu_1_txt
         call disp_menu
         ld hl,menu_2_txt
         call disp_menu
         ld hl,menu_3_txt
         call disp_menu
         ld hl,menu_4_txt
         call disp_menu
         ld hl,menu_5_txt
         call disp_menu
         
wfkmenu:
         ROM_CALL(GET_KEY)
         cp 4
         jr z,hautmenu
         cp 1
         jr z,basmenu
         cp 9
         jr z,validmenu
         cp 55
         ret z
         jr wfkmenu
         

disp_menu:
         ld a,30
         ld (CURSOR_X),a
         ld a,(CURSOR_Y)
         add a,8                   ; on passe a la ligne de l'option suivante
         ld (CURSOR_Y),a
         ld a,(pos_menu)            ; chargement du numero curseur pour effectuer le test
         cp b                       ; si le (posmenu) = b donc
         call z,change_couleur_texte ; afficher le texte en blanc sur noir
         ROM_CALL(D_ZM_STR)
         res 3,(IY+$05)             ; rinitialisation en couleur normale
         inc b
         ret

change_couleur_texte:
         set 3,(IY+$05)
         ret


hautmenu:
         ld a,(pos_menu)
         or a
         jr z,wfkmenu
         dec a
         ld (pos_menu),a
         jr scroll_menu
basmenu:
         ld a,(pos_menu)
         cp 4
         jr z,wfkmenu
         inc a
         ld (pos_menu),a
         jr scroll_menu

validmenu:
         ld a,(pos_menu)
         or a
         jr z,new_game
         cp 1
         jp z,load_game
         cp 2
         jp z,options
         cp 3
         jp z,a_propos
         cp 4
         ret z
         jr wfkmenu
         
menu_1_txt:
         .db " New game ",0
menu_2_txt:
         .db " Load game ",0
menu_3_txt:
         .db " Options ",0
menu_4_txt:
         .db " About ",0
menu_5_txt:
         .db " Quit ",0
         
; **********************  Preparation des modes de jeu  ************************
new_game:
; ---> Generateur de table aleatoire
table_generator:
         ; ---> on range les bords droits et bas dans l'ordre si le mode est "facile"
         ld a,(level)
         cp 1
         jr z,table_generator_lbl

         ld hl,rand_table + 3
         ld (hl),3             ; on place correctement une image sur le bord de droite
         ld hl,table_test + 3
         ld (hl),1             ; le role du "1" dans la table de test expliqu plus loin ...
         ld hl,rand_table + 7
         ld (hl),7
         ld hl,table_test + 7
         ld (hl),1
         ld hl,rand_table + 11
         ld (hl),11
         ld hl,table_test + 11
         ld (hl),1
         ld hl,rand_table + 12
         ld (hl),12
         inc hl
         ld (hl),13
         inc hl
         ld (hl),14
         inc hl
         ld (hl),15
         ld hl,table_test + 12
         ld (hl),1
         inc hl
         ld (hl),1
         inc hl
         ld (hl),1
         inc hl
         ld (hl),1
         

table_generator_lbl:
         xor a
         ld i,a                ; i = compteur
         push af
         ld de,rand_table      ; de = adresse de la table des chiffres aleatoires
table_gen:
         ld a,(level)
         or a
         call z,table_gen_inc_counter

         CALL GET_RAND         ; genere un nombre aleatoire entre 0 et 255
         
         and %00001111         ; on obtient un nombre qui a pour valeur maximale 15 et minimale 0 (tendue = 16)
         ld hl,table_test      ; on charge la table de verification ...
         ld b,0
         ld c,a                ; on test si le chiffre gnr existe
         add hl,bc             ; on se place au chiffre de la table de test
         ld a,(hl)             ; a = 0 ou 1
         or a                  ; si a = 1 ... (chiffre deja enregistr)
         jr nz,table_gen       ; ... alors on genere un nouveau chiffre
         
         ld (hl),1             ; on signal que l'on va enregistrer le chiffre dans la table de test
         ld a,c
         ld (de),a             ; enregistrement du chiffre gnr dans la table

         ld a,i
         inc a
         ld i,a
         
         pop af
         inc de

         inc a                 ; on test si l'instruction a t repetee 16 fois
         push af
         ld b,16
         call test_level_gen
         cp b
         jr nz,table_gen       ; si non, on relance

         pop af                ; on a fini de generer la table, donc on vide la pile
         jp debut
         
         
test_level_gen:
         push af
         ld a,(level)               ; si le niveau = 1 (mode difficile)
         cp 1
         jr z,test_level_gen_return; ... alors on n'a pas besoin de modifier "b" et on revient
         ld b,9                     ; sinon on reduit la hauteur maximale
test_level_gen_return:
         pop af
         ret
         
table_gen_inc_counter:
         ld a,i
         cp 3                  ; si on a repet la boucle 3 fois dans la ligne,
         jr z,table_gen_inc_de
         ret
         
table_gen_inc_de:
         inc de
         xor a
         ld i,a
         ret
         
; ************************  Chargement de la partie  ***************************
load_game:
         ld hl,save            ; copie la sauvegarde dans la table aleatoire
         ld de,rand_table
         ld bc,16
         ldir
         
         ld hl,save + 16
         ld a,(hl)
         ld (time_min),a
         inc hl
         ld a,(hl)
         ld (time_sec),a
         inc hl
         
         ld a,(hl)
         ld (level),a
         
         jp debut
         
; *************************  Menu des options  *********************************
options:
         CALL CR_GRBCopy     ; efface le texte et laisse apparaitre la banniere
         
options_mode1:
         ld hl,$0003
         ld (CURSOR_POS),hl
         ld hl,level_txt
         ROM_CALL(D_ZT_STR)
         
wfk_options_1:
         ROM_CALL(GET_KEY)
         cp 9                ; touche ENTER
         jr z,options_mode2
         ld b,0
         cp 34               ; touche 1
         jr z,valid_option_1
         inc b
         cp 26               ; touche 2
         jr z,valid_option_1
         jr wfk_options_1
         
valid_option_1:
         ld a,b
         ld (level),a
         add a,$31           ; on va faire du self_modifying ...
         ld hl,level_txt + 13
         ld (hl),a      ; on affiche le numero du niveau dans la chaine
         jr options_mode1
         
         
options_mode2:
         ld hl,$0005
         ld (CURSOR_POS),hl
         ld hl,img_select_txt
         ROM_CALL(D_ZT_STR)
         
wfk_options_2:
         ROM_CALL(GET_KEY)
         cp 9                ; touche ENTER
         jp z,demarrage
         ld b,0
         cp 34               ; touche 1
         jr z,valid_option_2
         inc b
         cp 26               ; touche 2
         jr z,valid_option_2
         inc b
         cp 18               ; touche 3
         jr z,valid_option_2
         ;inc b
         ;cp 35               ; touche 4
         ;jr z,valid_option_2
         ;inc b
         ;cp 27               ; touche 5
         ;jr z,valid_option_2
         ;inc b
         ;cp 19               ; touche 6
         ;jr z,valid_option_2
         jr wfk_options_2

valid_option_2:
         ld a,b
         ld (img_select),a
         add a,$31           ; on va faire du self_modifying ...
         ld hl,img_select_txt + 13
         ld (hl),a      ; on affiche le numero du niveau dans la chaine
         jr options_mode2
         
level_txt:
         .db "Level (1-2): 1",0
img_select_txt:
         .db "Image (1-3): 1",0
         
         
; ******************************  A Propos  ************************************
a_propos:
         ROM_CALL(CLEAR_LCD)
         set 3,(IY+$05)
         ld hl,0
         ld (CURSOR_POS),hl
         ld hl,about_txt1
         ROM_CALL(D_ZT_STR)

         ld hl,$0501
         ld (CURSOR_POS),hl
         ld hl,about_txt2
         ROM_CALL(D_ZT_STR)
         res 3,(IY+$05)
         
         ld hl,$0403
         ld (CURSOR_POS),hl
         ld hl,about_txt3
         ROM_CALL(D_ZT_STR)
         
         ld hl,$0005
         ld (CURSOR_POS),hl
         ld hl,about_txt4
         ROM_CALL(D_ZT_STR)

         CALL PAUSE
         jp demarrage
         

about_txt1:
         .db "  Puzzlin' v.1  "
         .db 0
about_txt2:
         .db "Deus Makina"
         .db 0
about_txt3:
         .db "June 2003"
         .db 0
about_txt4:
         .db "www.tidev.fr.st tidev@fr.st"
         .db 0
         
; ******************************************************************************
; **************************  Debut du programme  ******************************
; ******************************************************************************

; **************** Chargement des images et du puzzle sur l'ecran **************
debut:
         call select_img            ; charge dans le buffer (img_addr) l'adresse de l'image du puzzle voulu
         ld (img_addr),hl

         xor a
         ld (mode),a                ; (pour la selection de la fleche)

         ld hl,img_fond             ; -> chargement de l'image
         ld de,GRAPH_MEM
         ld bc,768
         ldir
         CALL CR_GRBCopy
         

         ld hl,table_test           ; on classe la table_test pour afficher le modele dans l'ordre
         ld b,16
         xor a
init_table_2:
         ld (hl),a
         inc hl
         inc a
         djnz init_table_2
         
         ; -> copiages des 2 tableaux du puzzle
         ld bc,GRAPH_MEM + 8        ; coordonnees d'affichage du puzzle
         ld hl,table_test           ; label de la table
         ld de,(img_addr)
         call tile_map_modified

         ld bc,GRAPH_MEM + 337      ; coordonnees d'affichage du puzzle
         ld hl,rand_table           ; label de la table
         ld de,(img_addr)
         call tile_map_modified


; **************** Debut des instructions des caracteristiques *****************
         call blocs_restants
         ld h,0
         ld l,a
         ld a,55
         ld (CURSOR_Y),a
         ld a,60
         ld (CURSOR_X),a
         set 7,(IY+$14)
         CALL HL_DECI
         ROM_CALL(D_ZM_STR)         ; affiche le nombre de blocs restants
         res 7,(IY+$14)

	 call act_mode_fleche       ; -> affiche de la fleche sur le mode correspondant
	 
	 call print_carre_grille
	 
wfk:
         call time_count
         ROM_CALL(GET_KEY)
         cp 55                      ; touche MODE
         jp z,confirm_quit          ; (on demande une confirmation ...)
         cp 51                      ; touche zoom
         call z,prof_key
         cp 9
         call z,pause2

         ld hl,table_pad_coo        ; coordonnees du selecteur: on pointe vers les coo X
         cp 54
         jr z,valid_phase_test_select ; validation du choix
         cp 2
         jr z,gauche_haut
         cp 3
         jr z,droite_bas
         inc hl                     ; on pointe maintenant sur les Y
         cp 4
         jr z,gauche_haut
         cp 1
         jr z,droite_bas
         jr wfk
         
gauche_haut:
         ld e,a                     ; e contient la derniere touche pressee
         ld a,(hl)
         or a
         jr z,wfk                   ; si on est au bord gauche ou haut maximum, on redemande 1 touche
         dec (hl)                   ; sinon on recule d'une case a gauche
         CALL CR_GRBCopy
         call print_carre_grille
         jr wfk
droite_bas:
         ld e,a
         ld a,(hl)
         ld b,3                     ; b = valeur par defaut (mode difficile)
         call test_level            ; on test si on doit modifier la largeur maximale a cause du niveau de difficulte
         cp b
         jr z,wfk                   ; si on est au bord droit ou bas maximum, on redemande 1 touche
         inc (hl)                   ; sinon on recule d'une case a gauche
         CALL CR_GRBCopy            ; (permet d'effacer la grille)
         call print_carre_grille
         jr wfk
         
test_level:
         push af
         ld a,(level)               ; si le niveau = 1 (mode difficile)
         cp 1
         jr z,test_level_return     ; ... alors on n'a pas besoin de modifier "b" et on revient
         dec b                      ; sinon on reduit la largeur maximale
test_level_return:
         pop af
         ret
         
; -------- Test de la validation ----------
valid_phase_test_select:
         ld hl,table_pad_coo
         ld c,(hl)                  ; c = axe des X
         inc hl                     ; on passe a l'axe des y
         ld a,(hl)
         add a,a
         add a,a                    ; on multiplie la valeur des axes des y par 4 car il y a 4 blocs par ligne
         add a,c                    ; "a" contient le nombre de blocs a partir du 1er
         
         ld hl,rand_table
         ld b,0
         ld c,a
         add hl,bc                  ; hl pointe sur le numero du blocs selectionn dans la table aleatoire
         
         ld de,table_pad_coo        ; "de" sert a tester les coordonnees du curseur (pour etre sur que l'on ne se trouve pas au bord de la grille ...)
         ld b,2                     ; b va indiquer de quelle ct se trouve le 0 (le 2 represente le code de la touche de gauche car c'est la premiere touche a tester)
         
         ; ---> on va tester si il y a un "0" autour du bloc (0 correspond a la case vide)
phase_test_select_gauche:           ; a = axe X du selecteur de grille
         ld a,(de)
         or a                       ; si le selecteur est plac sur le bord gauche, donc le 0 ne peut pas etre a gauche ...
         jr z,phase_test_select_droite ; ... donc on test a droite
         push hl
         dec hl
         ld a,(hl)
         pop hl
         or a
         jr z,phase_move_0_find     ; si le 0 est a gauche, donc en va lenregistrer
         
phase_test_select_droite:
         inc b                      ; on passe au ct suivant, donc on inc b (code de la fleche droite)
         ld a,(de)
         cp 3
         jr z,phase_test_select_haut
         push hl
         inc hl
         ld a,(hl)
         pop hl
         or a
         jr z,phase_move_0_find     ; si le 0 est a droite, donc en va lenregistrer
         
phase_test_select_haut:
         inc b                      ; (fleche du haut)
         inc de                     ; on passe a l'axe des y
         ld a,(de)
         or a
         jr z,phase_test_select_bas
         push hl
         ld de,-$0004
         add hl,de
         ld a,(hl)
         pop hl
         or a
         jr z,phase_move_0_find
         
phase_test_select_bas:
         ld b,1                     ; (fleche du bas)
         ld a,(de)
         cp 3
         jp z,wfk                   ; si on est au bord du bas (on a deja tout test), donc il n'y a pas de 0 a cot du selecteur et on redemande de rester 1 touche
         push hl
         ld de,$0004
         add hl,de
         ld a,(hl)
         pop hl
         or a
         jr z,phase_move_0_find
         jp wfk                     ; on a pas trouv de 0 donc on retourne chercher 1 touche
         
         
phase_move_0_find:
         ; on connait deja de quel cot est situ le 0, la valeur est stocke dans b (2 pour la gauche, 3 pour la droite, 4 pour le haut et 1 pour le bas)
         ld hl,mode
         inc (hl)
         call act_mode_fleche      ; on dessine la nouvelle fleche

wfk2:
         call time_count
         ROM_CALL(GET_KEY)
         or a
         jr z,wfk2
         cp 5
         jr c,move_selecteur       ; si la touche presse a un code compris entre 1 et 4 (les fleches) donc on les garde
         cp 56                     ; touche "DEL"
         jp z,debut                ; (pour annuler)
         cp 51                     ; touche zoom
         call z,prof_key
         cp 9
         call z,pause2
         jr wfk2
         
move_selecteur
         cp b                      ; si la touche pressee != cot du 0
         jr nz,wfk2                ; donc on retourne a la boucle

         ; sinon on passe a la validation et on deplace les blocs ...
; *******************  Inversion de la position des blocs  *********************
         ld hl,rand_table
         ld a,(table_pad_coo + 1)    ; axe des Y
         add a,a
         add a,a
         ld e,a
         ld a,(table_pad_coo)        ; axe des X
         add a,e
         ld d,0
         ld e,a
         add hl,de                   ; hl pointe vers le curseur selectionn
         push hl
         pop de                      ; hl -> de
         
         ld a,b
         cp 2                        ; (gauche)
         jr z,valid_gauche
         cp 3                        ; (droite)
         jr z,valid_droite
         cp 4                        ; (haut)
         jr z,valid_haut
         cp 1                        ; (bas)
         jr z,valid_bas
         
valid_gauche:
         dec de                      ; de = addresse du 2e bloc a deplacer
         jr rotation_blocs
valid_droite:
         inc de                      ; de = addresse du 2e bloc a deplacer
         jr rotation_blocs
valid_haut:
         push hl
         ld de,-$0004
         add hl,de
         ex de,hl                    ; de = hl - 4
         pop hl
         jr rotation_blocs
valid_bas:
         push hl
         ld de,$0004
         add hl,de
         ex de,hl                    ; de = hl + 4
         pop hl

rotation_blocs:  ; ---> on inverse les positions des 2 blocs dans la rand_table
         ld a,(hl)
         push af
         ld a,(de)
         ld (hl),a
         pop af
         ld (de),a                   ; les blocs sont maintenant inverss
         
         call blocs_restants         ; s'il tous les blocs ne sont pas encore bien placs
         or a                        ; ... alors on relance la sequence
         jp nz,debut
         
; ---------------  Victoire et Highscores  --------------
victory:
         ld hl,GRAPH_MEM
         ld de,GRAPH_MEM + 1
         ld (hl),0
         ld bc,767
         ldir

         ld bc,GRAPH_MEM + 384      ; coordonnees d'affichage du puzzle
         ld hl,rand_table           ; label de la table
         ld de,(img_addr)
         call tile_map_modified
	 
	 ld b,6
	 ld hl,GRAPH_MEM + 389
vict_draw_line:
         ld (hl),%11111111
         inc hl
         djnz vict_draw_line
         CALL CR_GRBCopy
         
	
         ld hl,$080E			    ; colonne: 15, ligne: 08
	 ld (GRAF_CURS),hl
	 ld hl,congratulation_txt
	 set 3,(IY+$05)
	 ROM_CALL(D_ZM_STR)
	 
	 ld hl,$153C                        ; colonne: 23, ligne: 60
         ld (GRAF_CURS),hl
         call disp_time
         res 3,(IY+$05)

         xor a
         ld (CURSOR_X),a
         ld hl,your_time_is_txt
	 ROM_CALL(D_ZM_STR)
	 
	 ld hl,$2B24                        ; colonne: 36, ligne: 43
         ld (GRAF_CURS),hl
         ld hl,high_score_txt
         ROM_CALL(D_ZM_STR)
         

         ld hl,$3538                       ; colonne: 53, ligne: 55
	 ld (GRAF_CURS),hl
         ld a,(time_min)
         push af
         ld a,(high_score_list)
         ld (time_min),a
         ld a,(time_sec)
         push af
         ld a,(high_score_list + 1)
         ld (time_sec),a
         call disp_time
         
         pop af
         ld (time_sec),a
         pop af
         ld (time_min),a


         ld a,(high_score_list)
	 ld b,a
	 ld a,(high_score_list + 1)
	 add a,b
	 or a                          ; si a = 0 c'est qu'il n'y a jamais eu de high score ...
	 jr z,new_high_score
	
         ld hl,time_min
	 CALL LD_HL_MHL
	 ex de,hl                      ; d = temps personnel en min, e = temps personnel en sec
         ld hl,high_score_list
	 CALL LD_HL_MHL                     ; h = high score en min, l = high score en sec
	 CALL CP_HL_DE
	 jr nc,new_high_score

         CALL PAUSE
	 ret
	 
	 
new_high_score:
         ld hl,$2424                   ; colonne: 36, ligne: 33
         ld (GRAF_CURS),hl
         ld hl,new_high_score_txt
	 ROM_CALL(D_ZM_STR)
	 
	 ld a,(time_min)
	 ld (high_score_list),a
	 ld a,(time_sec)
	 ld (high_score_list + 1),a
	 CALL PAUSE
	 ret
	 
congratulation_txt:
         .db " Congratulation !! ",0
your_time_is_txt:
         .db "Your time is:",0
high_score_txt:
         .db "High Score:",0
new_high_score_txt:
         .db "New high score !!",0
high_score_list:
         .db 0,0
         
         
; ********************************  Quitter  ***********************************
confirm_quit:
         push af
         push hl
         set 3,(IY+$05)
         ld hl,$0000
         ld (GRAF_CURS),hl
         ld hl,confirm_quit_txt
         ROM_CALL(D_ZM_STR)

         ld hl,$0600                              ; colonne: 00, ligne: 06
         ld (GRAF_CURS),hl
         ld hl,confirm_save_txt
         ROM_CALL(D_ZM_STR)
         
         ld hl,$0C00                              ; colonne: 00, ligne: 12
         ld (GRAF_CURS),hl
         ld hl,confirm_cancel_txt
         ROM_CALL(D_ZM_STR)
         res 3,(IY+$05)
         
wfk_confirm_quit:
         ROM_CALL(GET_KEY)
         cp 34                               ; touche 1
         jr z,quit_prev                      ; on ne peut pas quitter directement car il faut vider la pile
         cp 26                               ; touche 2
         jr z,save_game_prev
         cp 18                               ; touche 3
         jr z,wfk_prev                            ; (on repart juste a la boucle qui a appelee la routine)
         jr wfk_confirm_quit
         
quit_prev:
         pop hl
         pop af
         jp demarrage
save_game_prev:
         pop hl
         pop af
         jr save_game
wfk_prev:
         CALL CR_GRBCopy
         call print_carre_grille
         pop hl
         pop af
         jp wfk
         
confirm_quit_txt:
         .db " 1: Quit         ",0
confirm_save_txt:
         .db " 2: Save       ",0
confirm_cancel_txt:
         .db " 3: Cancel",0
         
         
; ************************  Sauvegarde du jeu  *********************************
save_game:
         ld hl,rand_table              ; on copie la table dans la sauvegarde
         ld de,save
         ld bc,16
         ldir
         
         ld hl,save + 16
         ld a,(time_min)               ; on copie le temps
         ld (hl),a
         inc hl
         ld a,(time_sec)
         ld (hl),a
         inc hl
         
         ld a,(level)                  ; on enregistre le niveau de difficulte
         ld (hl),a
         jp demarrage                  ; on retourne au menu principal
	
; ******************************************************************************
; *******************************  Routines  ***********************************
; ******************************************************************************

; ******************  Routine Tile Map (by Deus Makina) modifiee  **************
	
tile_map_modified:
        ld a,4
        ld (temp1_tile_m),a           ; temp1 = colonne = 4
        ld (temp2_tile_m),a           ; temp2 = ligne   = 4
        
calcul_table:
        push de
        ld a,(hl)
        add a,a
        add a,a
        add a,a
        push bc
        ld c,a
        ld b,0
        ex de,hl
        add hl,bc
        ex de,hl               ; "de" pointe vers la premiere sprite a afficher
        pop bc
        ld a,8                 ; -> compteur des 8 lignes (hauteur d'une sprite)
        push hl
        
print_sprite:
        push af
        ld a,(de)
        ld (bc),a
        pop af
        inc de
        ld h,b
        ld l,c
        ld bc,12
        add hl,bc
        ld b,h
        ld c,l                 ; bc = ligne suivante du graph_mem
        dec a
        jr nz,print_sprite
        
        pop hl
        pop de
        inc hl                 ; on passe au sprite suivant (dans la table)
        push hl
        ld h,b                 ; bc -> hl = GRAPH_MEM
        ld l,c
        ld bc,-$005F           ; = 88 = -96+8
        add hl,bc
        ld b,h                 ; -> de = GRAPH_MEM + 1 (sprite suivant)
        ld c,l
        pop hl

        ld a,(temp1_tile_m)
        dec a                  ; on decremente la colonne
        ld (temp1_tile_m),a
        jr nz,calcul_table
        
inc_bande_tile_map:
        ld a,4
        ld (temp1_tile_m),a
        push hl
        ld h,b                 ; bc -> hl = GRAPH_MEM
        ld l,c
        ld bc,$005C            ; on ajoute 96 pour passer a la ligne suivante (96 - 4[largeur du puzzle])
        add hl,bc
        ld b,h                 ; -> de = GRAPH_MEM + 1 (sprite suivant)
        ld c,l
        pop hl

        ld a,(temp2_tile_m)    ; la partie haute de a est maintenant en partie basse
        dec a
        or a                   ; si a = 0 (on a fini d'afficher le puzzle)
        ret z                  ; on a fini d'afficher le puzzle si la condition est vraie
        ld (temp2_tile_m),a
        jp calcul_table
        
        

; ********************** Calcul des blocs restants a placer ********************

blocs_restants:
        push hl
        push de
        push bc
        ld hl,rand_table
        ld de,table_test
        ld bc,$1000             ; b= 16 car le puzzle contient 16 blocs  et "c" sert de compteur pour les blocs restants

loop_blocs_restants:
        push bc
        ld a,(hl)
        ld c,a
        ld a,(de)
        inc hl                  ; on passe au bloc suivant de la liste
        inc de                  ;  "   "    "   "     "     "  "   "
        cp c                    ; si a=c donc le bloc est a la bonne place et on n'incremente pas le registre "c"
        pop bc
        jr z,blocs_restants_phase2
        inc c
        
blocs_restants_phase2:
        djnz loop_blocs_restants
        
        ld a,c                  ; "a" contient le nombre de blocs restants a bien placer
        pop bc
        pop de
        pop hl
        ret
        
        
; ************* affiche de la fleche sur le mode correspondant *****************
act_mode_fleche:
        push af
        push bc
        push hl
        set 7,(IY+$14)
        ld b,3
        ld a,35
loop_clear_fleche:
        ld (CURSOR_Y),a
        push af
        ld a,42
        ld (CURSOR_X),a
        ld hl,clear_fleche_txt
        ROM_CALL(D_ZM_STR)
        pop af
        add a,6
        djnz loop_clear_fleche
        
        ld a,(mode)
        ld c,a
        add a,a                 ; a = 6*a (espacement entre cahque option)
        add a,a
        add a,c
        add a,c
        add a,35                ; 37 a ajouter pour commencer au debut du menu
        ld (CURSOR_Y),a
        ld a,42
        ld (CURSOR_X),a
        ld a,$05                ; code de la fleche
        ROM_CALL(M_CHARPUT)
        res 7,(IY+$14)
        CALL CR_GRBCopy
        call print_carre_grille     ; pour ne pas laisser le petit carre effac
        pop hl
        pop bc
        pop af
        ret
clear_fleche_txt:
        .db "   ",0
        
; ******************** affiche le carr sur la grille **************************
print_carre_grille:

        ld a,(table_pad_coo)
        ld c,a
        add a,a
        add a,a
        add a,c
        add a,73
        ld (CURSOR_X),a

        ld a,(table_pad_coo + 1)
        ld c,a
        add a,a
        add a,a
        add a,c
        add a,38
        ld (CURSOR_Y),a
        
        set 3,(IY+$05)
        ld hl,carre_grille                ; code du carr
        ROM_CALL(D_ZM_STR)
        res 3,(IY+$05)
        ret
carre_grille:
        .db $20,$20,$20,$20,0
        
; ********************************  Pause 2  ***********************************
pause2:
        push af
        ld a,(mode)
        push af
        ld a,2
        ld (mode),a
        call act_mode_fleche
        CALL PAUSE
        pop af
        ld (mode),a
        call act_mode_fleche
        pop af
        ret
        
; ******************************  Prof Key *************************************
prof_key:
        push af
        ROM_CALL(CLEAR_LCD)
wfk_profkey:
        ROM_CALL(GET_KEY)
        cp 51
        jr nz,wfk_profkey
        CALL CR_GRBCopy
        call print_carre_grille     ; pour ne pas laisser le petit carre effac
        pop af
        ret
        
        
; **************************  Compteur du temps  *******************************
time_count:
        push af
        push hl
        push bc
        ld a,(time_counter)
        inc a
        ld (time_counter),a
        cp 100                         ; 110 boucles = 1 seconde
        call z,inc_sec
        
        ld a,26
        ld (CURSOR_Y),a
        ld a,43
        ld (CURSOR_X),a
        call disp_time
        pop bc
        pop hl
        pop af
        ret

disp_time:
        ld h,0
        ld a,(time_min)
        ld l,a
        cp 10
        call c,time_aff_0
        CALL HL_DECI
        ROM_CALL(D_ZM_STR)
        
        ld a,$27
        ROM_CALL(M_CHARPUT)
        
        ld h,0
        ld a,(time_sec)
        ld l,a
        cp 10
        call c,time_aff_0
        CALL HL_DECI
        ROM_CALL(D_ZM_STR)
        ret

inc_sec:
        xor a
        ld (time_counter),a
        ld a,(time_sec)
        inc a
        ld (time_sec),a
        cp 60
        jr z,inc_min
        ret
        
inc_min:
        xor a
        ld (time_sec),a
        ld a,(time_min)
        inc a
        ld (time_min),a
        ret
        
time_aff_0:
        push af
        ld a,$30
        ROM_CALL(M_CHARPUT)
        pop af
        ret
        
; **********************  Selectionne Image *************************
select_img:
	  ld hl,img_type1
	  ld a,(img_select)
   	  or a
	  ret z
	  ld hl,img_type2
	  cp 1
	  ret z
	  ld hl,img_type3	  
	  ret
	
        

save:                               ; la table a deja ete generee aleatoirement
         .db 3,11,13,10
         .db 14,15,4,6
         .db 1,5,0,12
         .db 9,2,7,8
         .db 0,0                    ; temps (minutes puis secondes)
         .db 1                      ; niveau de difficult
         
         
banniere:
; Width:96 Height:16 (192 bytes)
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$04,$00
	.db $00,$00,$00,$63,$00,$00,$03,$30,$03,$00,$0E,$00
	.db $00,$00,$01,$CF,$00,$00,$06,$30,$04,$00,$1F,$00
	.db $00,$00,$07,$BF,$00,$00,$06,$30,$08,$00,$00,$00
	.db $1F,$E0,$09,$E7,$6F,$F3,$E6,$16,$C0,$00,$3F,$C0
	.db $15,$64,$03,$C6,$ED,$F3,$EC,$EF,$C1,$01,$20,$48
	.db $1A,$AE,$07,$8E,$CF,$E7,$CC,$6C,$C3,$83,$A9,$5C
	.db $15,$6F,$07,$0C,$CC,$81,$0C,$6D,$C3,$C7,$A0,$5E
	.db $1A,$AE,$0E,$79,$D9,$E3,$CE,$FD,$83,$83,$A9,$5C
	.db $15,$64,$1E,$F0,$FB,$E7,$C8,$DD,$81,$01,$26,$48
	.db $1A,$A0,$1C,$60,$04,$08,$00,$00,$00,$00,$20,$40
	.db $1F,$E0,$38,$00,$00,$00,$00,$00,$00,$00,$3F,$C0
	.db $00,$00,$30,$92,$49,$24,$92,$49,$24,$00,$00,$00
	.db $00,$00,$43,$6D,$B6,$DB,$6D,$B6,$DB,$00,$1F,$00
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$0E,$00
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$04,$00
        

img_fond:
; Width:96 Height:64 (768 bytes)
	.db $00,$00,$00,$00,$00,$00,$00,$05,$30,$00,$00,$00
	.db $00,$63,$00,$00,$03,$30,$03,$05,$29,$2B,$00,$00
	.db $01,$CF,$00,$00,$06,$30,$04,$01,$2A,$AA,$00,$00
	.db $07,$BF,$00,$00,$06,$30,$08,$05,$2B,$29,$00,$00
	.db $09,$E7,$6F,$F3,$E6,$16,$C0,$05,$31,$BB,$00,$00
	.db $03,$C6,$ED,$F3,$EC,$EF,$C0,$01,$00,$00,$00,$00
	.db $07,$8E,$CF,$E7,$CC,$6C,$C0,$05,$22,$08,$80,$00
	.db $07,$0C,$CC,$81,$0C,$6D,$C0,$01,$36,$68,$31,$80
	.db $0E,$79,$D9,$E3,$CE,$FD,$80,$01,$2A,$AA,$AA,$80
	.db $1E,$F0,$FB,$E7,$C8,$DD,$80,$01,$22,$AC,$AA,$80
	.db $1C,$60,$04,$08,$00,$00,$00,$01,$22,$6A,$A9,$80
	.db $38,$00,$00,$00,$00,$00,$00,$01,$00,$00,$00,$00
	.db $30,$92,$49,$24,$92,$49,$24,$01,$00,$00,$00,$00
	.db $43,$6D,$B6,$DB,$6D,$B6,$DB,$01,$00,$00,$00,$00
	.db $00,$00,$00,$00,$00,$00,$00,$01,$00,$00,$00,$00
	.db $00,$00,$00,$00,$00,$00,$00,$01,$00,$FF,$FF,$00
	.db $00,$00,$00,$00,$00,$00,$00,$01,$00,$00,$00,$00
	.db $00,$00,$00,$00,$00,$00,$00,$01,$00,$00,$00,$00
	.db $6D,$B6,$DB,$6D,$B6,$DB,$6D,$81,$30,$00,$0D,$04
	.db $92,$49,$24,$92,$49,$24,$92,$41,$2A,$BD,$E4,$64
	.db $24,$92,$49,$24,$92,$49,$24,$C1,$32,$88,$45,$50
	.db $49,$24,$92,$49,$24,$92,$49,$41,$22,$90,$85,$50
	.db $92,$49,$24,$92,$49,$24,$92,$41,$23,$BD,$E5,$50
	.db $6D,$B6,$DB,$6D,$B6,$DB,$6D,$81,$00,$00,$00,$00
	.db $00,$00,$00,$00,$00,$00,$00,$05,$00,$00,$00,$00
	.db $80,$00,$00,$00,$00,$00,$00,$01,$00,$00,$00,$00
	.db $00,$00,$00,$00,$00,$00,$00,$05,$00,$FF,$FF,$00
	.db $B1,$FF,$FF,$FF,$FF,$80,$00,$05,$00,$00,$00,$00
	.db $A9,$FF,$FF,$FF,$FF,$80,$00,$01,$00,$00,$00,$00
	.db $31,$81,$81,$81,$81,$80,$00,$05,$00,$00,$00,$00
	.db $A9,$81,$81,$81,$81,$80,$00,$05,$00,$00,$00,$00
	.db $B1,$81,$81,$81,$81,$80,$00,$05,$00,$00,$00,$00
	.db $81,$81,$81,$81,$81,$80,$00,$05,$FF,$FF,$FF,$FF
	.db $A9,$81,$81,$81,$81,$80,$00,$04,$00,$00,$00,$00
	.db $A9,$81,$81,$81,$81,$96,$FF,$FF,$F6,$80,$02,$DF
	.db $91,$FF,$FF,$FF,$FF,$80,$00,$00,$00,$00,$00,$01
	.db $21,$FF,$FF,$FF,$FF,$80,$60,$C0,$10,$00,$00,$01
	.db $81,$81,$81,$81,$81,$80,$84,$48,$D8,$00,$00,$01
	.db $81,$81,$81,$81,$81,$80,$4A,$55,$10,$FF,$FF,$F8
	.db $01,$81,$81,$81,$81,$80,$2C,$59,$10,$84,$21,$09
	.db $81,$81,$81,$81,$81,$80,$C6,$4C,$C8,$84,$21,$09
	.db $31,$81,$81,$81,$81,$80,$00,$00,$00,$84,$21,$08
	.db $29,$81,$81,$81,$81,$80,$88,$00,$00,$84,$21,$09
	.db $29,$FF,$FF,$FF,$FF,$80,$D9,$29,$00,$FF,$FF,$F8
	.db $29,$FF,$FF,$FF,$FF,$80,$AA,$AA,$80,$84,$21,$08
	.db $31,$81,$81,$81,$81,$80,$8A,$AB,$00,$84,$21,$08
	.db $01,$81,$81,$81,$81,$80,$89,$11,$80,$84,$21,$08
	.db $11,$81,$81,$81,$81,$80,$00,$00,$00,$84,$21,$08
	.db $29,$81,$81,$81,$81,$80,$C0,$00,$00,$FF,$FF,$F8
	.db $31,$81,$81,$81,$81,$80,$A6,$AC,$80,$84,$21,$08
	.db $19,$81,$81,$81,$81,$80,$CA,$A9,$40,$84,$21,$08
	.db $01,$FF,$FF,$FF,$FF,$80,$8A,$A5,$80,$84,$21,$08
	.db $29,$FF,$FF,$FF,$FF,$80,$86,$EC,$C0,$84,$21,$08
	.db $29,$81,$81,$81,$81,$80,$00,$00,$00,$FF,$FF,$F8
	.db $A9,$81,$81,$81,$81,$96,$FF,$FF,$68,$84,$21,$09
	.db $39,$81,$81,$81,$81,$80,$00,$00,$00,$84,$21,$08
	.db $81,$81,$81,$81,$81,$90,$0A,$00,$00,$84,$21,$09
	.db $B1,$81,$81,$81,$81,$90,$93,$00,$00,$84,$21,$09
	.db $21,$81,$81,$81,$81,$91,$5A,$40,$00,$FF,$FF,$F8
	.db $91,$FF,$FF,$FF,$FF,$91,$92,$00,$00,$00,$00,$01
	.db $B1,$FF,$FF,$FF,$FF,$9C,$D1,$40,$00,$00,$00,$01
	.db $80,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$01
	.db $80,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$01
	.db $FB,$40,$00,$00,$00,$00,$00,$00,$00,$00,$02,$DF
        
.include "imgpuz.inc"
.end
