; PICreator for Puzzlin'
; **********************
; By Deus Makina
; June 2003
; www.tidev.fr.st

; What's PICreator ?
; ------------------
; This program writes in PICx a picture from the file "creator.inc".
; It asks you to choose in which PIC you want to copy your photo (because it
; can't directly create a PIC). Press a key between 1 and 6. If there is no PIC
; in the RAM, you'll see "PIC not found" on the screen. Else, press [ENTER] to
; confirm your choice or "MODE" to cancel. After to see "Success !", press
; [ENTER] to quit.

; To change your image, create one of 96*93, convert it in hex or binary, then
; copy the result after the label "new_img" and compile the program.

; ******************************************************************************
; ******************************************************************************
; ******************************************************************************
.include "acebeta.inc"
         .db "PICreator  by Deus Makina",0
         
         ROM_CALL(CLEAR_LCD)
         
         ld hl,$0400
         ld (CURSOR_POS),hl
         ld hl,title_txt
         ROM_CALL(D_ZT_STR)
         
         ld hl,$0002
         ld (CURSOR_POS),hl
         ld hl,choix_pic_txt
         ROM_CALL(D_ZT_STR)
         
         call wfk_pic
         
         ld a,b
         cp 6                    ; si "MODE" (b->6) avait t pressee, on quitte
         ret z
         
         ld hl,datas_pic + 2
         ld (hl),a               ; datas_pic+2 pointe sur le numero du PIC
         ld hl,pic_select_txt + 6
         add a,$31               ; on doit additionner $31 pour avoir la valeur des chiffres de la table ASCII
         ld (hl),a               ; on ecrit le numero du PIC choisi dans le text
         
         ld hl,$0005
         ld (CURSOR_POS),hl
         ld hl,pic_select_txt
         ROM_CALL(D_ZT_STR)
         

         ; ---> Test si PICx existe deja ...
         CALL DEL_TMP       ; on "ouvre" les pointeurs de mmoire pour toute recherche dans la VAT
         ld hl,datas_pic
         rst 20h            ; on copie le contenu point par hl dans OP1
         CALL FIND_VAT      ; OP1 = info du programme ($07=type[PIC], 60 00 = type de "token" [PIC1] 0=fin de chaine)
                            ; -> de = contient l'adresse de debut de programme dans la mem user
                            ; -> active le carry flag si non trouv
         jr c,pic_not_found ; si le PIC n'existe pas (on ne peut donc pas ecrire dessus), on quitte ...
         
         ; ---> on copie la nouvelle image dans PICx qui existe deja
confirm:
         CALL GET_KEY
         cp 55               ; touche [MODE]
         jr z,quit_pgrm
         cp 9                ; touche [ENTER]
         jr nz,confirm
         
         inc de              ; on se place au debut de la mmoire de PICx
         inc de
         ld hl,new_pic       ; copie l'image dans PICx
         ld bc,756           ; not 768 !!!
         ldir
         
         ld hl,$0007
         ld (CURSOR_POS),hl
         ld hl,success_txt
         ROM_CALL(D_ZT_STR)
         jr quit_pgrm
         
         
pic_not_found:
         ld hl,$0007
         ld (CURSOR_POS),hl
         ld hl,pic_not_found_txt
         ROM_CALL(D_ZT_STR)
         
quit_pgrm:
         CALL PAUSE
         CALL CREATE_TMP
         ret
         
         
wfk_pic:
         CALL GET_KEY
         ld b,0                   ; b = compteur a 0
         cp 34                    ; si "1" pressee -> b = 0
         ret z
         inc b
         cp 26                    ; si "2" pressee -> b = 1
         ret z
         inc b
         cp 18                    ; si "3" pressee -> b = 2
         ret z
         inc b
         cp 35                    ; si "4" pressee -> b = 3
         ret z
         inc b
         cp 27                    ; si "5" pressee -> b = 4
         ret z
         inc b
         cp 19                    ; si "6" pressee -> b = 5
         ret z

         inc b
         cp 55                    ; si "MODE" pressee -> b = 6
         ret z
         jr wfk_pic
         
         
         
title_txt:
         .db "PICreator",0
choix_pic_txt:
         .db "Choose the PIC  number:",0
pic_select_txt:
         .db $D8," PIC  ",0
         
pic_not_found_txt:
         .db "PIC not found !",0
success_txt:
         .db "Success !!",0
         
datas_pic:
         .db $07            ; type de programme
         .db $60,00         ; PIC1
         .db 0              ; fin de chaine
         
         
.include "creator.inc"
.end
